﻿using UnityEngine;
using System.Collections;

public class ptlight3 : MonoBehaviour {
	private Light ptlight;
	float targettime;
	float timer;
	public float flashtime; // seconds
	Vector3 fflyposition;

	// RTcmix/audio stuff
	private int objno = 2;
	private rtcmixmain RTcmix;
	int trigaudio;
	private getMyTransform localsrc; // to get position relative to 'observer'


	// Use this for initialization
	void Start () {
		ptlight = GetComponent<Light>();
		ptlight.intensity = 0.0f;
		ptlight.range = 0.0f;

		targettime = Random.Range (1.0f, 3.0f);
		timer = 0.0f;
		if (flashtime == 0.0f) // in case it hasn't been set
			flashtime = 1.0f;

		// position
		fflyposition.Set(Random.Range(-5.0f, 5.0f), Random.Range(-2.0f, 2.0f), Random.Range(-5.0f, 5.0f));
		transform.position = fflyposition;

		// RTcmix stuff
		localsrc = GameObject.Find ("observer").GetComponent<getMyTransform> ();
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		// we do this because sometimes RTcmix doesn't get initialized completely here
		RTcmix.SendScore ("MAXBANG(0.1)", objno);
	}
	
	// Update is called once per frame
	void Update () {
		if (Time.time > targettime) {
			float glow = Mathf.PingPong (timer, 1.0f);
			ptlight.intensity = glow;
			ptlight.range = glow * 2.0f;

			fflyposition.Set(fflyposition.x + Random.Range(-0.1f, 0.1f),
				fflyposition.y + Random.Range(-0.1f, 0.1f),
				fflyposition.z + Random.Range(-0.1f, 0.1f));
			transform.position = fflyposition;

			// WAVETABLE(outsk, dur, AMP, PITCH[, PAN, WAVETABLE])
			// MOOGVCF(outsk, insk, dur, AMP, inputchan, PAN, BYPASS, FILTFREQTABLE, FILTRESONTABLE)
			if (trigaudio == 0) {
				// flashtime is doubled for rise & fall in Mathf.PingPong()
				RTcmix.SendScore ("WAVETABLE(0, " + flashtime*2.0f + ", 20000*ampenv, 10.04 + (pmod*pmodamp), 0.5, wave) " +
					"MOOGVCF(0, 0, " + flashtime*2.0f + ", 1, 0, 0.5, 0, cfreq, 0.9) ", objno);
				trigaudio = 1;
			}

			// if sound is happening, update the location
			// note the the Z and the Y axis get swapped because of the way Unity labels them
			if (RTcmix != null) {
				Vector3 srcpos = localsrc.getTransform (gameObject); // this source relative to the 'observer' object
				RTcmix.setpfieldRTcmix (1, srcpos.x, objno);
				RTcmix.setpfieldRTcmix (2, srcpos.y, objno);
				RTcmix.setpfieldRTcmix (3, srcpos.z, objno);
			}

			timer += (Time.deltaTime * (1.0f / flashtime));
	
			if (timer > 2.0f) { // one ping-pong cycle complete
				targettime = Time.time + Random.Range (1.0f, 3.0f);
				timer = 0.0f;
				trigaudio = 0;
			}
		}
	}

	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			// note the the Z and the Y axis get swapped because of the way Unity labels them
			// added a makefilter("smooth" ...) to smooth out jumping from the firefly wiggles
			RTcmix.SendScore ("srand() " +
				"bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
				"bus_config(\"MOOGVCF\", \"aux 0-1 in\", \"aux 2-3 out\") " +
				"bus_config(\"LOCALIZE\", \"aux 2-3 in\", \"out 0-1\")  " +
				"ampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
				"cfreq = maketable(\"line\", \"nonorm\", 1000, 0,500, 1,1500, 2,500) " +
				"wave = maketable(\"wave\", 1000, \"saw\") " +
				"pmod = makerandom(\"even\", 20, 0.01, 0.12) " +
				"pmodamp = maketable(\"line\", 1000, 0,0, 1,0, 2,1) " +
				"srcXt = makeconnection(\"inlet\", 1, 1)  " +
				"srcYt = makeconnection(\"inlet\", 2, 0)  " +
				"srcZt = makeconnection(\"inlet\", 3, 5)  " +
				"srcX = makefilter(srcXt, \"smooth\", 70) " +
				"srcY = makefilter(srcYt, \"smooth\", 70) " +
				"srcZ = makefilter(srcZt, \"smooth\", 70) " +
				"LOCALIZE(0, 0, 9999, 1,  srcX, srcZ, srcY,  0, 0, 0,  1, 1,  0,  1, 2)", objno);
		}
	}

	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
